package com.itheima;

import com.itheima.bean.Stock;
import com.itheima.lock.DbLock;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class StockMain {
    //private  static Lock lock=new ReentrantLock();
    @Autowired
    private static DbLock dbLock;



    static {
        ClassPathXmlApplicationContext classPathXmlApplicationContext= new ClassPathXmlApplicationContext("applicationContext.xml") ;
        dbLock=classPathXmlApplicationContext.getBean(DbLock.class);
    }

    static  class StockThread implements  Runnable{
        public void run() {
            //上锁
           // lock.lock();
            dbLock.lock();
            //调用减少库存的方法
            boolean b=new Stock().reduceStock();
            //解锁
            //lock.unlock();
            dbLock.unlock();
            if(b)
            {
                System.out.println(Thread.currentThread().getName()+"减少库存成功");
            }else
            {
                System.out.println(Thread.currentThread().getName()+"减少库存失败");
            }
        }
    }


    public  static void main(String[] args)
    {
        new Thread(new StockThread(),"线程1").start();
        new Thread(new StockThread(),"线程2").start();
    }
}
